<?php defined('SYSPATH') or die('No direct script access.');

class Model_Leveringen extends Kohana_Model
{
	public function getLevering($bestelid)
	{
		try{
			$levering=array();
			$sql="SELECT b.bestelid as leveringid, b.bestelid, b.leverancierid, c.voornaam, c.naam, b.leveringsnr, b.leveranciergroepid as groepid, lgroep.omschrijving as groep,
					b.leverancierid, l.naam as leverancier, IFNULL(l.straatnr,'') as straatnr, IFNULL(l.postcode,'') as postcode, IFNULL(l.plaats,'') as plaats,
					b.datum, IF(b.controle=1,DATE(b.controledatum),IFNULL(b.leveringvan, b.bestelleveringvan)) as leveringvan
				FROM bestellingleverancier b
				LEFT JOIN leverancier l ON b.leverancierid = l.leverancierid
				LEFT JOIN contact c ON c.contactid=b.registrator
				LEFT JOIN leveranciergroepomschrijving lgroep ON lgroep.leveranciergroepid=b.leveranciergroepid
				WHERE b.bestelid =:bestelid ;";
			$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':bestelid'=>$bestelid));
			$db=$query->execute()->as_array();
			if(isset($db[0]['leveringid'])){
				$levering=$db[0];
				//ARTIKELS
				$sql="SELECT bl.artikelid, ao.omschrijving, UPPER(la.code) as levcode,UPPER(la.informatie) as levomschrijving,
					ROUND(bl.aantal/bl.eenheden,0) as aantal, bl.eenheden as eenheden,
					IF(art.verkoopseenheidtype=1,1,0) as stukartikel,  wms_qty_cases_accepted as aantalcontrole, IFNULL(ROUND(wms_qty_pieces_accepted/wms_qty_cases_accepted,2),0) as eenhedencontrole
					FROM bestellingleverancierlijn bl
					LEFT JOIN artikelomschrijving ao ON ao.artikelid=bl.artikelid AND ao.taalid=1
					LEFT JOIN leverancierartikel la ON la.artikelid=bl.artikelid AND la.leverancierid=:levid
					LEFT JOIN artikel art on art.artikelid=bl.artikelid
					WHERE bl.bestelid=:bestelid
					ORDER BY bl.artikelid ";
				$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':bestelid'=>$bestelid,':levid'=>$levering['leverancierid']));
				$levering['artikels']=$query->execute()->as_array();

				//LEEGGOED
				$sql="SELECT l.leeggoedid, l.omschrijving, l.omschrijvingKort, IFNULL(ll.prijs,l.prijs) as prijs, bll.aantal
					FROM leverancierleeggoed ll
					LEFT JOIN leeggoed l on l.leeggoedid=ll.leeggoedid
					LEFT JOIN bestellingleverancierleeggoed bll ON bll.leeggoedid=ll.leeggoedid AND bll.bestelid=:bestelid
					WHERE ll.leverancierid=:levid
					ORDER BY l.volgnummer";
				$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':bestelid'=>$bestelid,':levid'=>$levering['leverancierid']));
				$levering['leeggoed']=$query->execute()->as_array();
			}

			return $levering;
		} catch(Exception $e) {
			Log::instance()->add(Log::ERROR, $e->getMessage());
			return array();
		}
	}

	public function getLeveringenDatum($leveringvan)
	{
		try{
			$leveringen=array();
			$sql="SELECT b.bestelid as leveringid, b.bestelid, b.leverancierid, c.voornaam, c.naam, b.leveringsnr, b.leveranciergroepid as groepid, lgroep.omschrijving as groep,
					b.leverancierid, l.naam as leverancier, IFNULL(l.straatnr,'') as straatnr, IFNULL(l.postcode,'') as postcode, IFNULL(l.plaats,'') as plaats,
					b.datum, IFNULL(b.leveringvan, b.bestelleveringvan) as leveringvan
				FROM bestellingleverancier b
				LEFT JOIN leverancier l ON b.leverancierid = l.leverancierid
				LEFT JOIN contact c ON c.contactid=b.registrator
				LEFT JOIN leveranciergroepomschrijving lgroep ON lgroep.leveranciergroepid=b.leveranciergroepid
				WHERE b.bevestigd=1 AND IFNULL(b.leveringvan, b.bestelleveringvan) =:leveringvan
				ORDER BY b.bestelid;";
			$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':leveringvan'=>$leveringvan));
			$db=$query->execute()->as_array();
			foreach($db as $lev){
				$levering=$lev;
				//ARTIKELS
				$sql="SELECT bl.artikelid, ao.omschrijving, UPPER(la.code) as levcode,UPPER(la.informatie) as levomschrijving,
					 ROUND(bl.aantal/bl.eenheden,0) as aantal, bl.eenheden as eenheden,
					 bl.wms_qty_cases_accepted as aantalcontrole, IFNULL(ROUND(bl.wms_qty_pieces_accepted/bl.wms_qty_cases_accepted,2),0) as eenhedencontrole
					FROM bestellingleverancierlijn bl
					LEFT JOIN artikelomschrijving ao ON ao.artikelid=bl.artikelid AND ao.taalid=1
					LEFT JOIN leverancierartikel la ON la.artikelid=bl.artikelid AND la.leverancierid=:levid
					LEFT JOIN artikel art on art.artikelid=bl.artikelid
					WHERE bl.bestelid=:bestelid
					ORDER BY bl.artikelid ";
				$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':bestelid'=>$lev['leveringid'],':levid'=>$lev['leverancierid']));
				$levering['artikels']=$query->execute()->as_array();

				//LEEGGOED
				$sql="SELECT l.leeggoedid, l.omschrijving, l.omschrijvingKort, IFNULL(ll.prijs,l.prijs) as prijs, bll.aantal
					FROM leverancierleeggoed ll
					LEFT JOIN leeggoed l on l.leeggoedid=ll.leeggoedid
					LEFT JOIN bestellingleverancierleeggoed bll ON bll.leeggoedid=ll.leeggoedid AND bll.bestelid=:bestelid
					WHERE ll.leverancierid=:levid
					ORDER BY l.volgnummer";
				$query =  DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':bestelid'=>$lev['leveringid'],':levid'=>$lev['leverancierid']));
				$levering['leeggoed']=$query->execute()->as_array();

				array_push($leveringen,$levering);
			}

			return $leveringen;
		} catch(Exception $e) {
			Log::instance()->add(Log::ERROR, $e->getMessage());
			return array();
		}
	}

	//Bevestig bestelling die is aangemaakt door aankoper
	//enkel voor leveranciers apart (geen groep bestellingen)
	//bevestiging kan door aankoper, leverancier of onbekend iemand (bevestigings pagina via mail)
	public function setLeveringLeverancier($geg)
	{
		try{
			$mailsturen=TRUE;
			if(isset($geg['mailsturen']) && $geg['mailsturen']==0){
				$mailsturen=FALSE;
			}
			$nota= str_replace('\n', '<br />', $geg['nota']);
			$nota=trim($nota);

			$artikels=array();
			if(isset($geg['artikels'])){
				$artikels=$geg['artikels'];
			}
			$bestelid=intval($geg['bestelid']);
			$leverdatum=$geg['leverdatum'];
			$leeggoed=$geg['leeggoed'];

			//controleren of er bestelling is anders enkel nota versturen
			Database::instance()->begin();
			//INSERT LEVERING LEVERANCIER
			//artikels aantallen aanpassen en update
			foreach($artikels as $artikel){
				if($artikel['levomschrijving']==null) $artikel['levomschrijving']=NULL;
				if($artikel['levcode']==null) $artikel['levcode']=NULL;

				//CONTROLE DUBBELE BEVESTIGING via bevestig pagina of VMI
				$sql="SELECT IFNULL(bevestigd,0) as bevestigd
						FROM bestellingleverancierlijn
						WHERE bestellingleverancierlijnid=:lijnid";
				$query = DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':lijnid'=>$artikel['lijnid']));
				$bevestigcheck=$query->execute()->as_array();
				if($bevestigcheck[0]['bevestigd']==1){
					throw new Exception('Wij constateren dat deze bestelling al bevestigd is.');
				}

				$sql="UPDATE leverancierartikel
						SET prijs=:prijs, code=:code, informatie=:omschr
						WHERE leverancierid=:levid AND artikelid=:artikelid";
				$query = DB::query(Database::UPDATE, $sql, FALSE)
							->parameters(array(':prijs'=>$artikel['prijs'],
										':code'=>$artikel['levcode'],
										':omschr'=>$artikel['levomschrijving'],
										':levid'=>$artikel['levid'],
										':artikelid'=>$artikel['artikelid']))->execute();
				if($artikel['aantal']>0 && $artikel['eenheden']==null){
					$artikel['eenheden']=1;
				}

				//UPDATE BESTELLINGLEV LIJN (OUD)
				$sql="UPDATE bestellingleverancierlijn blijn
						LEFT JOIN leverancierartikel lart ON lart.leverancierid=:levid AND blijn.artikelid=lart.artikelid
						LEFT JOIN artikel art ON art.artikelid=blijn.artikelid
						SET  blijn.prijs=	ROUND(IF(lart.oververpakking=1,(lart.prijs/ IF(art.verkoopseenheidtype=1,art.omverpakking,art.coefficient)),lart.prijs) + IFNULL(lart.kost,0),2) ,
							blijn.aantal=:aantal, blijn.prijsingegeven=:prijsingegeven, blijn.eenheden=:eenheden, blijn.bevestigd=1,
							blijn.coefficient=art.coefficient
							WHERE blijn.bestellingleverancierlijnid=:lijnid ";
				$query = DB::query(Database::UPDATE, $sql, FALSE)
					->parameters(array(':aantal'=>$artikel['aantal']*$artikel['eenheden'],
										':levid'=>$artikel['levid'],
										':prijsingegeven'=>$artikel['prijs'],
										':eenheden'=>$artikel['eenheden'],
										':lijnid'=>$artikel['lijnid']))->execute();
			}

			//leeggoed toevoegen / aanpassen
			if(!empty($leeggoed)){
				foreach($leeggoed as $lg){
					$sql="SELECT aantal
						FROM bestellingleverancierleeggoed
						WHERE bestelid=:bestelid AND leeggoedid=:leeggoedid";
					$query = DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':bestelid'=>$bestelid,':leeggoedid'=>$lg['leeggoedid']));
					$dblg=$query->execute()->as_array();
					if(empty($dblg) && ($lg['aantal']>0)){
						//insert
						DB::insert('bestellingleverancierleeggoed')
							->columns(array('bestelid','leeggoedid','aantal'))
							->values(array($bestelid,$lg['leeggoedid'],$lg['aantal']))->execute();
					}else{
						//update
						$sql="UPDATE bestellingleverancierleeggoed
							SET aantal=:aantal
							WHERE bestelid=:bestelid AND leeggoedid=:leeggoedid";
						DB::query(Database::UPDATE, $sql, FALSE)
							->parameters(array(':aantal'=>$lg['aantal'],':bestelid'=>$bestelid,':leeggoedid'=>$lg['leeggoedid']))->execute();
					}
				}
			}

			//nota
			//kijken of er al nota is
			if(!empty($nota)){
				$sql="SELECT nota
						FROM bestellingleveranciernota
						WHERE bestelid=:bestelid";
				$query = DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':bestelid'=>$bestelid));
				$dbnota=$query->execute()->as_array();
				if(empty($dbnota)){
					$nota="++++".date('Y-m-d H:i:s')."++++<br/>".$nota."<br/>";
					//insert
					DB::insert('bestellingleveranciernota')
						->columns(array('bestelid','nota'))
						->values(array($bestelid,$nota))->execute();
				}else{
					$nota=$dbnota[0]['nota']."<br/>++++".date('Y-m-d H:i:s')."++++<br/>".$nota."<br/>";
					//update
					$sql="UPDATE bestellingleveranciernota
							SET nota=:nota
							WHERE bestelid=:bestelid ";
					DB::query(Database::UPDATE, $sql, FALSE)
							->parameters(array(':nota'=>$nota,':bestelid'=>$bestelid))->execute();
				}
			}

			//bestelling bevestigen
			$sql="UPDATE bestellingleverancier bl
					LEFT JOIN (SELECT :bestelid as bestelid, IFNULL(SUM(bevestigd),1) as bevestigdlijn
						FROM bestellingleverancierlijn WHERE bestelid=:bestelid AND bevestigd=0
					) bll ON bll.bestelid=bl.bestelid
					SET bl.bevestigd=bll.bevestigdlijn, bl.leveringvan=:leveringvan
					WHERE bl.bestelid=:bestelid ";
			DB::query(Database::UPDATE, $sql, FALSE)->parameters(array(':leveringvan'=>$leverdatum,':bestelid'=>$bestelid))->execute();

			//Log::instance()->add(Log::INFO, "TEST: ".$bestelid);
			//Levering OPHALEN
			$levering=$this->getLevering($bestelid);
			//Log::instance()->add(Log::INFO, json_encode($levering));

			//gegevens klaarmaken om mail te sturen
			$tomail=Kohana::$config->load('appconf.tomail');

			$mdlLev= new Model_Leverancier();
			if($mailsturen){
				$contacten=$mdlLev->getContactenLeverancierMail($levering['leverancierid'],1);
				$tomail.=",".$contacten['mail'];
			}

			//Log::instance()->add(Log::INFO, "TEST: START MAIL");

			$mdl=new Model_Mail();
			$mdl->setSubject("[DESADV: ".$levering['leveringid']."] ".$levering['leverancierid']. " ".$levering['leverancier']);
			$mdl->setTo(array_unique(explode(",",rtrim($tomail,","))));
			$mdl->mailDesadv($levering,$nota);

			//Transport contact ophalen
			$contacten=$mdlLev->getContactenLeverancierMail($levering['leverancierid'],4);
			if(!empty($contacten['mail'])){
				$mdl=new Model_Mail();
				$mdl->setSubject("[DESADV: ".$levering['leveringid']."] ".$levering['leverancierid']. " ".$levering['leverancier']);
				$mdl->setTo(array_unique(explode(",",rtrim($contacten['mail'],","))));
				$mdl->mailDesadvTransport($levering,$nota);
			}

			//changes detecteren
			$sql="SELECT c.mail
					FROM bestellingleverancier b
					LEFT JOIN bestellingleverancierlijn bl ON b.bestelid=bl.bestelid
					LEFT JOIN contact c ON c.contactid=b.registrator
					WHERE (b.bestelleveringvan!=b.leveringvan OR bl.bestelaantal!=bl.aantal OR bl.besteleenheden!=bl.eenheden) AND b.bestelid=:bestelid";
			$query = DB::query(Database::SELECT, $sql, FALSE)->parameters(array(':bestelid'=>$bestelid));
			$dbchange=$query->execute()->as_array();
			if(!empty($dbchange)){
				$mdl=new Model_Orders();
				$bestelling=$mdl->getBestelling($bestelid);
				$mdl=new Model_Mail();
				$mdl->setSubject("[CHANGES: ".$bestelling[0]['bestelid']."] ".$bestelling[0]['leverancierid']. " ".$bestelling[0]['leverancier']);
				$mdl->setTo(array("purchase.direct@greenyardfresh.be",$dbchange[0]['mail']));
				$mdl->mailChanges($bestelling[0]);
			}

			Database::instance()->commit();
			$response['success']=true;
			$response['titel']="Info";
			$response['message']="Gegevens zijn opgeslagen en verstuurd. ";
		}catch(Exception $e){
			Database::instance()->rollback();
			$response['success'] = false;
			$response['titel']="Error";
			$response['message'] = $e->getMessage();
			Log::instance()->add(Log::ERROR, $e->getMessage());
		}
		return $response;
	}


}
