<?php
require_once('assets/pdf/fpdf/fpdf.php');
class HistoriekPDF extends FPDF{
	var $gegevens;

	function setGegevens($geg) {
 		$this->gegevens = $geg;
	}
	
	function Header()
	{
		$this->AddFont('Calibri','','calibri.php');
		$this->AddFont('Calibri','I','calibrii.php');
		$this->AddFont('Calibri','B','calibrib.php');
		$this->AddFont('CalibriLight','I','calibrili.php');
		
		$this->SetTextColor(0);
		$header=$this->gegevens;
		# header image
		$this->Image('assets/images/GREENYARD_RGB_32.png',10,10);
		$this->SetTextColor(51,102,51);
		$this->SetDrawColor(51,102,51);
		$this->Cell(62,9,"",'B',1,"L");
		$this->SetFont('Calibri','',11);
		$this->Cell(0,6,"Greenyard Fresh Direct Belgium NV",0,1,"L");
		
		$this->SetXY(200,10);
		$this->SetFont('CalibriLight','I',20);
		$this->Cell(20,6,"Fresh",0,1,"L");
		
		$this->Ln(10);
		# header info
		$this->SetTextColor(64,64,64);
		$this->SetFont('Calibri','',10);
		$this->Cell(200,6,"VMI Historiek ".$header['naam']." (".$header['leverancierid'].")",0,0,"L");
		$this->SetFont('Calibri','',8);
		$this->Cell(80,6,'p '.$this->PageNo().'/{nb}' ,0,0,"R");
		$this->Ln(2);
	

		$this->SetFont('Calibri','',10);
		$this->SetTextColor(50);
		$this->Ln();

	}

	function Footer()
	{		
		$this->SetTextColor(100,100,100);
    	$this->SetY(-9);
    	$this->SetFont('Calibri','',7);
		//$this->Cell(94,3,'Printed '.date('d-m-Y').' Created by LunaSoft',0,0,'L');
		//$this->Cell(93,3,'pag '.$this->PageNo().'/{nb}',0,0,'C');
		//$this->Image('assets/images/GY_FAHF_darkgreen_RGB_200x22.png',235,200);
		
		$this->Image('assets/images/GY_FAHF_darkgreen_RGB_600x67.png',245,194,43);
        $this->Image('assets/images/gy_line_1200x6.png',10,200,280,1);
		
	}
	
	function HistoriekTabel($gegevens)
	{
		$h=5;
		$this->SetFont('Calibri','B',10);
		$this->SetTextColor(51,102,51);
		$w=array(10,60,60,15,15,15,15,15,15,15,15,15,15,15,15,15,15);
		$header=array("Code","Omschrijving","Code Leverancier","HS","O");
		$now = strtotime("now");
		for ($i=1;$i<9;$i++){
			array_push($header,strftime("%a", strtotime('-'.$i.' days',$now)));
		}

		
		for($i=0; $i<count($header); $i++){
			$this->Cell($w[$i],$h,$header[$i],1,0,"C");
		}
		$this->Ln();
		$this->SetFont('Calibri','',10);
		$this->SetTextColor(64, 64, 64);
		foreach($gegevens as $i=>$artikel){
			if($this->GetY()+15>$this->PageBreakTrigger){
				$this->addPage();
				$this->SetFont('Calibri','B',10);
				$this->SetTextColor(51,102,51);
				for($i=0; $i<count($header); $i++){
					$this->Cell($w[$i],$h,$header[$i],1,0,"C");
				}
				$this->Ln();
				$this->SetFont('Calibri','',10);
				$this->SetTextColor(64, 64, 64);
			}	
			$this->Cell($w[0],$h,$artikel['artikelid'],1,0,"R");
			$this->Cell($w[1],$h,utf8_decode($artikel['omschrijving']),1,0,"L");
			$this->Cell($w[2],$h,utf8_decode($artikel['levcode']." ".$artikel['levomschrijving']),1,0,"L");
			$this->Cell($w[3],$h,$artikel['stock'],1,0,"R");
			$this->Cell($w[3],$h,$artikel['inorder'],1,0,"R");
			for ($i=0;$i<8;$i++){
				$this->Cell($w[3],$h,$artikel['lb_his_d'.$i],1,0,"R");
			}
			
			/*foreach($artikel['levering'] as $index=>$aantal){
				$this->Cell($w[3],$h,$aantal,1,0,"R");
			}*/

			$this->Ln();
		}
		$this->Ln(5);
	}

		
}
?>
